<!--       
*     Copyright © 1997, 2011, Oracle and/or its affiliates. All rights reserved.
*     Use is subject to license terms.
-->
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
    <head>
        <title>Specify Resource Classes (Client-Item)</title>
        <meta content="text/html; charset=UTF-8" http-equiv="Content-Type">
        <link rel="stylesheet" href=
              "nbdocs://org.netbeans.modules.usersguide/org/netbeans/modules/usersguide/ide.css" type="text/css">
        <meta name="keywords" content="options, php">
    </head>
    <body>
        <p> <small><a href="#seealso">See Also</a>&nbsp; </small> 
        <h2>Specify Resource Classes (Client-Item)</h2>
        <p>Container-Item RESTful web services consist of an item resource class and its container resource class. Both item and container use Java API for RESTful Web Service (JSR-311). </p>
        <p>There are two ways to add  an item resource to a container-item RESTful service. One way is to use the POST method on the container resource class. In this case, the URI for the newly created item resource is determined by the container resource. The other way to add an item resource is to use the PUT method on the item resource class. This approach is called the <em>Client-Controlled Container-Item pattern</em>, because the URI for the item resource is determined by the client and not the container resource.</p>
        <p>This panel contains the following fields, which specify the class name, URI, and representation type of the resource.
        </p>
        <ul>
            <li><strong>Resource Name.</strong> Name for an item resource. Default is <code>/Item</code>.</li> 
            <li><strong>Class Name.</strong> Name for the item resource class. Default is <code>ItemResource</code>.</li>
            <li><strong>Container Class Name.</strong> Name of the container class. Default is <code>ItemsResource</code>.</li>
            <li><strong>Project.</strong> The NetBeans IDE project containing this RESTful service. The value is generated by the IDE.</li>
            <li><strong>Location.</strong> The parent directory inside the NetBeans IDE project that contains the RESTful service. By default this is the Source Packages directory.</li>
            <li><strong>Resource Package.</strong> The package containing the RESTful service classes. Select from a drop-down list of packages or type the name of a new package. These packages are in the directory specified in the Location field.</li>
            <li><strong>Path.</strong> The path of an item resource, passed as an argument of the <code>@Path</code> annotation for the container's method that gets an instance of the item resource. For Container-Item services, the Path is a variable that identifies individual instances of the item resource class. The default value of Path is <code>{id}</code>.</li>
            <li><strong>Container Path.</strong> The path of the container resource, passed as an argument of the <code>@Path</code> annotation for the container class declaration. By default the Path is <code>/Items</code>.</li>
            <li><strong>MIME Type.</strong> MIME type of RESTful service requests and responses, passed as arguments of the <code>@Produces</code> and <code>@Consumes</code> annotations. The default MIME type is application/xml. Therefore the default <code>@Produces</code> and <code>@Consumes</code> annotations are <code>@Produces("application/xml")</code> and <code>@Consumes("application/xml")</code>.</li>
    <li><strong>Representation Class.</strong> Class of the representation of the item resource class instance returned by a get method. Default class is <code>java.lang.String</code>.</li>
    <li><strong>Container Representation Class.</strong> Class of the representation of the container resource class instance returned by a get method. Default class is <code>java.lang.String</code>.</li>
        </ul>
        <dl> 
            <dt><a name="seealso">See Also</a></dt>

            <dd><a href="../../about/about_rest.html">About RESTful Web Services</a></dd>
            <dd><object classid="java:org.netbeans.modules.javahelp.BrowserDisplayer">
                    <param name="content" value="http://docs.oracle.com/cd/E19776-01/820-4867/ggqyl/index.html">
                    <param name="text" value="<html><u>The Storage-Service Application</u></html>">
                    <param name="textFontSize" value="medium">
                    <param name="textColor" value="blue">
                </object></dd>
        </dl>

        <hr><small><a href="../../../credits.html">Legal Notices</a></small>

        <table border="0" cellpadding="20">
            <tr><td>&nbsp;</td></tr>
            <tr><td>&nbsp;</td></tr>
            <tr><td>&nbsp;</td></tr>
        </table>
    </body>
</html>
